<?php
//----------------------------------------
// leverage order ui functions
//----------------------------------------
function leverage_order_ui() {
    $rate   = input_rate();
    $amount = input_amount();
    $order_type = input_leverage_buy_sell();
    printf( "Rate[BTC/JPY] : %d" . PHP_EOL .
            "Amount[BTC]   : %f" . PHP_EOL .
            "Price[JPY]    : %f" . PHP_EOL .
            "Order type    : %s" . PHP_EOL
            , $rate, $amount, $rate*$amount, $order_type);
    if(!yes_no_quit()) {
        die(0);
    }
    $order = array('rate'=>$rate,
                    'amount'=>$amount,
                    'order_type'=>$order_type);
    return $order;
}
//----------------------------------------
function input_amount() {
    while(TRUE) {
        print("Amount[BTC](quit if empty): ");
        $n = trim(fgets(STDIN));
        if(empty($n)) {
            print("Quit." . PHP_EOL);
            die(0);
        } elseif(!is_numeric($n)) {
            printf("[ERROR] " . $n . " is not numeric." . PHP_EOL);
        } else {
            break;
        }
    }
    return $n;
}
//----------------------------------------
function input_rate() {
    while(TRUE) {
        print("Rate[BTC/JPY](quit if empty): ");
        $rate = trim(fgets(STDIN));
        if(empty($rate)) {
            print("Quit." . PHP_EOL);
            die(0);
        } elseif(!ctype_digit($rate)) {
            printf("[ERROR] " . $rate . " is not integer." . PHP_EOL);
        } else {
            break;
        }
    }
    return $rate;
}
//----------------------------------------
function input_leverage_buy_sell() {
    while(TRUE) {
        print("Order type [long/short](quit if empty): ");
        $type = trim(fgets(STDIN));
        if(empty($type)) {
            print("Quit." . PHP_EOL);
            die(0);
        } elseif(!strcasecmp($type, "short")) {
            $type = "leverage_sell";
            break;
        } elseif(!strcasecmp($type, "long")) {
            $type = "leverage_buy";
            break;
        } else {
            print("Please check the input." . PHP_EOL);
        }
    }
    return strtolower($type);
}
//----------------------------------------
function yes_no_quit() {
    while (TRUE) {
        print("OK? [yes/no/quit] :");
        $ok = trim(fgets(STDIN));
        if(!strcasecmp($ok, "yes")) {
            $ok = TRUE;
            break;
        } elseif(!strcasecmp($ok, "no")) {
            print("Order canceled." . PHP_EOL);
            $ok = FALSE;
            break;
        } elseif(!strcasecmp($ok, "quit")) {
            print("Quit." . PHP_EOL);
            $ok = FALSE;
            break;
        } else {
            print("Please check the input." . PHP_EOL);
        }
    }
    return $ok;
}
